Imports System.IO.Ports
Imports System.Threading
Imports System.Windows.Forms

Public Class I2C
    ' MAX232 invertiert
    Const bHigh As Byte = 0
    Const bLow As Byte = 1

    ' tinUSB invertiert nicht
    'Const bHigh As Byte = 1
    'Const bLow As Byte = 0

    Private MyCOM As SerialPort

    ' Define the property.
    Public Property Init_COM() As Object
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved. 
            Return MyCOM
        End Get
        Set(ByVal Value As Object)
            ' The Set property procedure is called when the value 
            ' of a property is modified. 
            ' The value to be assigned is passed in the argument to Set. 
            MyCOM = Value
        End Set
    End Property
    Sub SCL(ByVal iWert As Integer)

        If iWert = 0 Then           ' False = 0; True = alles andre
            'MyCOM.Rts = bLow        ' MAX232 invertiert
            MyCOM.RtsEnable = bLow
        Else
            'MyCOM.Rts = bHigh       ' MAX232 invertiert
            MyCOM.RtsEnable = bHigh
        End If

    End Sub
    Sub SDA(ByVal iWert As Integer)

        If iWert = 0 Then           ' False = 0; True = alles andre
            'MyCOM.Dtr = bLow        ' MAX232 invertiert
            MyCOM.DtrEnable = bLow
        Else
            'MyCOM.Dtr = bHigh       ' MAX232 invertiert
            MyCOM.DtrEnable = bHigh
        End If

    End Sub
    Function CTS() As Integer

        'If Not (MyCOM.ModemStatus = RS232.Rs232.ModemStatusBits.ClearToSendOn) Then   'RS232
        If Not (MyCOM.CtsHolding) Then
            Return bLow             ' MAX232 invertiert
        Else
            Return bHigh            ' MAX232 invertiert
        End If

    End Function
    Public Sub Init()
        SCL(True)      'SCL
        SDA(True)      'SDA
    End Sub

    Public Function Start(ByVal Addr As Byte) As Boolean
        'returns acknowledge

        SCL(True)       'SCL
        SDA(True)       'SDA
        SDA(False)      'SDA
        SCL(False)      'SCL
        'SDA True        'SDA         eventuell zuviel
        Return Write(Addr)

    End Function

    Public Sub xStop()
        SCL(True)
        SDA(False)
        SDA(True)
    End Sub

    Public Function Read() As Byte
        'Lesen eines Bytes mit Acknowledge   
        'Die Funktion read liet ein Byte und antwortet mit einem Acknowledge-Signal.
        'Das gelesene Byte wird zurckgegeben.
        Return _receive(True)

    End Function

    Public Function ReadLast() As Byte
        'Lesen eines Bytes ohne Acknowledge   
        'Die Funktion readlast liet ein Byte ohne Acknowledge-Signal
        Return _receive(False)

    End Function

    Function _receive(ByVal ackn As Boolean) As Byte
        'ackn =true  =read
        'ackn =false =readlast

        Dim receive As Byte

        receive = 0
        SDA(True)          'test
        SCL(True) '1
        SCL(True)
        If CTS() Then receive = 128
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 64
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 32
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 16
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 8
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 4
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 2
        SCL(False)

        SCL(True)
        If CTS() Then receive = receive + 1
        SCL(False)
        SCL(False)      'test

        If ackn Then
            SDA(False)
        Else
            SDA(True)
        End If

        SCL(True)
        SCL(True)       'test
        SCL(False)

        Return receive

    End Function

    Public Function Write(ByVal Data As Byte) As Boolean
        'Senden eines Bytes   
        'Die Funktion write sendet ein Byte.
        'Das Ergebnis der Funktion ist TRUE , wenn das angesprochene IC mit einem Acknowledge
        'geantwortet hat, andernfalls FALSE .

        Dim RetCode As Boolean
        Dim xTime As Long
        Dim Anfang As Date
        Dim Laufzeit As TimeSpan

        SCL(False)          ' bei Bit - Transfer SDA Change nur bei SCL = 0 erlaubt
        SDA(Data And &H80) '1
        SCL(True)
        SCL(False)

        SDA(Data And &H40) '2
        SCL(True)
        SCL(False)

        SDA(Data And &H20) '3
        SCL(True)
        SCL(False)

        SDA(Data And &H10) '4
        SCL(True)
        SCL(False)

        SDA(Data And &H8) '5
        SCL(True)
        SCL(False)

        SDA(Data And &H4) '6
        SCL(True)
        SCL(False)

        SDA(Data And &H2) '7
        SCL(True)
        SCL(False)

        SDA(Data And &H1) '8
        SCL(True)
        SCL(False)
        '---------------------------------
        SDA(True)
        SCL(True)
        SCL(True)        ' Test , etwas strecken
        Anfang = Now
        RetCode = False
        Do
            Thread.Sleep(5)
            Application.DoEvents()
            If CTS() = False Then
                RetCode = True         'Acknowledge SDA=0
            Else
                RetCode = False
            End If
            Laufzeit = Now.Subtract(Anfang)
            xTime = Laufzeit.TotalMilliseconds
        Loop While RetCode = False And Not xTime > 500 And Not xTime < 0

        SCL(False)
        Return RetCode

    End Function
    Public Function B2B(ByVal cWert As String) As Byte
        Return Bin2DezInByte(cWert)
    End Function
    Function Bin2DezInByte(ByVal cWert As String) As Byte

        '   Binr zu Dezimal
        '   MSB - LSB
        '   1110 -> 7

        Dim yErgebnis As Byte
        Dim i As Integer
        Dim iBis As Integer

        yErgebnis = 0
        iBis = Len(cWert)
        For i = 1 To iBis
            If Mid(cWert, i, 1) = "1" Then
                yErgebnis = yErgebnis + 2 ^ (iBis - i)
            End If
        Next i
        Return yErgebnis

    End Function

End Class
